
package de.ivu.elect.presentation.kandidatur;

import static org.apache.commons.lang3.StringUtils.isBlank;

import java.util.Collection;

import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.gebietsbaum.entity.Gebiet;
import de.ivu.elect.business.gruppe.entity.Gruppe;
import de.ivu.elect.business.kandidatur.boundary.EinzelbewerberKandidaturKonfiguration;
import de.ivu.elect.business.kandidatur.boundary.KandidaturConversationSelect;
import de.ivu.elect.business.kandidatur.entity.Listenkandidatur;
import de.ivu.elect.business.personenpruefung.boundary.PersonenKonfliktConversationSelect;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.business.wahl.entity.Wahl;
import de.ivu.elect.business.wahl.entity.Wahlart;
import de.ivu.elect.business.wahlvorschlag.boundary.EinzelbewerberWahlvoschlagEdit;
import de.ivu.elect.business.wahlvorschlag.boundary.WahlvorschlagsdokumentExtendedDAO;
import de.ivu.elect.business.wahlvorschlag.entity.Liste;
import de.ivu.elect.business.wahlvorschlag.entity.WahlvorschlagReihenfolgeBestaetigenEvent;
import de.ivu.elect.business.wahlvorschlag.entity.Wahlvorschlagsdokument;
import de.ivu.elect.jee.faces.PreConditionCheck;
import de.ivu.elect.jee.presentation.dynamicform.FormBuilder;
import de.ivu.elect.jee.presentation.redirect.Redirect;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.hilfe.OnlineHilfeId;
import de.ivu.elect.presentation.kandidatur.form.EinzelbewerberKandidaturViewFormBuilder;
import de.ivu.elect.presentation.wahlvorschlag.ListeSearchView;
import de.ivu.elect.presentation.wahlvorschlag.form.WahlvorschlagsdokumenteViewFormBuilder;

@OnlineHilfeId(value = "TODO", mehrfachVergebenOk = true)
@Named(EinzelbewerberListenkandidaturEditView.COMPONENT_NAME)
@View(viewId = EinzelbewerberListenkandidaturEditView.VIEW_ID, useCase = UseCasePermission.LISTENKANDIDATUR_EDIT)
public class EinzelbewerberListenkandidaturEditView extends AbstractListenkandidaturEditView {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "einzelbewerberListenkandidaturEditView";

  public static final String VIEW_ID = "/kandidatur/einzelbewerber-listenkandidatur-edit.xhtml";

  public static final String PARENT_VIEW_ID = ListeSearchView.VIEW_ID;

  @Inject
  protected transient EinzelbewerberWahlvoschlagEdit einzelbewerberWahlvoschlagEdit;

  @Inject
  protected transient WahlvorschlagsdokumentExtendedDAO wahlvorschlagsdokumentExtendedDAO;

  @Inject
  protected transient KandidaturConversationSelect uebergeordneteKandidaturSelect;

  @Inject
  protected transient EinzelbewerberKandidaturViewFormBuilder einzelbewerberKandidaturViewFormBuilder;

  @Inject
  protected transient WahlvorschlagsdokumenteViewFormBuilder wahlvorschlagsdokumenteViewFormBuilder;

  @Inject
  protected transient ErsatzkandidaturCreateViewResolver ersatzkandidaturCreateViewResolver;

  @Inject
  protected transient PersonenKonfliktConversationSelect personenKonfliktConversationSelect;

  @Inject
  protected transient WahlvorschlagReihenfolgeBestaetigenEvent wahlvorschlagReihenfolgeBestaetigenEvent;

  private Collection<Wahlvorschlagsdokument> wahlvorschlagsdokumente;

  public EinzelbewerberListenkandidaturEditView() {
    super();
  }

  @Override
  @PreConditionCheck
  public String checkPreCondition() {
    super.checkPreCondition();

    if (isEinzelkandidaturSelected()) {
      return null;
    }

    return cancel();
  }

  /*
   * Beachte: Muss überschrieben werden, da die VIEW_ID eine andere als im AbstractListenkandidaturEditView ist.
   */
  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  @Override
  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  @Override
  protected boolean isGebietBearbeitenRechtPruefen() {
    return true;
  }

  private boolean isEinzelkandidaturSelected() {
    return isEntitySet() && getEinzelliste().isEinzelbewerber();
  }

  private Gebiet getGebiet() {
    return getEntity().getGebiet();
  }

  public String getEinzelkandidaturName() {
    if (isEinzelkandidaturSelected()) {
      String name = getEntity().getFamilienname();

      if (isBlank(name)) {
        name = getEntity().getNamePraesentation();
      }

      return name;
    }

    return "";
  }

  public String getGebietName() {
    if (isEinzelkandidaturSelected()) {
      return gebietNummerFormatter.getNameMitNummer(getGebiet());
    }

    return "";
  }

  private Wahl getWahl() {
    return getGebiet().getWahl();
  }

  protected Wahlart getWahlart() {
    return getWahl().getWahlart();
  }

  protected Liste getEinzelliste() {
    return getEntity().getListe();
  }

  protected Gruppe getEinzelbewerber() {
    return getEntity().getGruppe();
  }

  protected Collection<Wahlvorschlagsdokument> getWahlvorschlagsdokumente() {
    if (wahlvorschlagsdokumente == null) {
      wahlvorschlagsdokumente = findWahlvorschlagsdokumente();
    }

    return wahlvorschlagsdokumente;
  }

  private Collection<Wahlvorschlagsdokument> findWahlvorschlagsdokumente() {
    return wahlvorschlagsdokumentExtendedDAO.findByWahlvorschlag(getEinzelliste());
  }

  @Override
  public void addProperties(FormBuilder formBuilder, Listenkandidatur einzelkandidatur) {
    boolean readonly = false;

    einzelbewerberKandidaturViewFormBuilder.addProperties(formBuilder, einzelkandidatur, readonly);

    wahlvorschlagsdokumenteViewFormBuilder.addProperties(formBuilder, getSelectedWahl(), getEinzelliste(), getWahlvorschlagsdokumente(), readonly);
  }

  @Override
  @Redirect
  @UseCaseSecure(UseCasePermission.LISTENKANDIDATUR_EDIT)
  public String save() {
    // ELECT-2788: Schließe den Konflikt, da er evtl. gelöst wurde.
    personenKonfliktConversationSelect.clearEntity();

    Listenkandidatur einzelkandidatur = getEntity();
    Liste einzelliste = getEinzelliste();

    einzelbewerberKandidaturViewFormBuilder.preSaveEntity(einzelkandidatur);

    einzelbewerberWahlvoschlagEdit.save(einzelliste);

    wahlvorschlagReihenfolgeBestaetigenEvent.sendWahlvorschlagReihenfolgeBestaetigenEvent(einzelliste.getPk());

    addMessageSaveSuccess(einzelkandidatur);

    conversationStore.close();

    return goBack(getParentViewId());
  }

  @Override
  protected void addMessageSaveSuccess(Listenkandidatur einzelkandidatur) {
    addInfoMessage("entity.edit.action.save.success.message", getMessage(EinzelbewerberKandidaturKonfiguration.MSG_KEY_EINZELBEWERBER_LISTENKANDIDATUR_EINZAHL));
  }

  @Override
  @Redirect
  @UseCaseSecure(UseCasePermission.LISTENKANDIDATUR_DELETE)
  public String delete() {
    einzelbewerberWahlvoschlagEdit.delete(getEinzelliste());

    addMessageDeleteSuccess();

    conversationStore.close();

    return getParentViewId();
  }

  @Override
  protected void addMessageDeleteSuccess() {
    addInfoMessage("entity.edit.action.delete.success.message", getMessage(EinzelbewerberKandidaturKonfiguration.MSG_KEY_EINZELBEWERBER_LISTENKANDIDATUR_EINZAHL));
  }

  public boolean isBtnSaveAndErsatzkandidaturCreateRendered() {
    // ELECT-2788: Keine Option bei der Bearbeitung eines Konflikts.
    if (personenKonfliktConversationSelect.isSelected()) {
      return false;
    }

    return hasPermission(UseCasePermission.ERSATZKANDIDATUR_CREATE) && ersatzkandidaturCreateViewResolver.isUntergeordneteErsatzkandidaturCreatable(getWahl(), getEntity());
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.ERSATZKANDIDATUR_CREATE)
  public String saveAndErsatzkandidaturCreate() {
    // NOTE, dass die Referenz VOR dem Speichern geholt werden muss, da der ConversationStore anschließend geschlossen wird!
    uebergeordneteKandidaturSelect.setEntity(getEntity());

    save();

    return ersatzkandidaturCreateViewResolver.getViewId(getMandant());
  }

  @Override
  protected FormBuilder createFormBuilder() {
    return new FormBuilder(formBuilderConfig);
  }
}
